<?

require_once "password_recovery_config.php";
require_once "smarty/libs/Smarty.class.php";
require_once "MDB2.php";
require_once "Mail.php";

$smarty = new Smarty;

$smarty->assign('title', $config['title']);
$error='';
$debug='';

try {
  $dbh = new PDO($config["DBdsn"],$config["DBuser"],$config["DBpassword"]);
} catch (PDOException $e) {
  $error .= 'Connection failed: ' . $e->getMessage();
}

function verify_email_syntax ($mail) {
  global $error;
  if ( preg_match("/^[-0-9a-zA-Z_\.\+]+@[-0-9a-zA-Z_\.\+]+$/", $mail))  {
    return true;
  } else {
    return false;
  }
}

function verify_user_exists ($mail) {
  global $dbh, $config;
  $sth=$dbh->prepare($config['sql_check_user']);
  if ($sth->execute(array($mail))) {
    while ($result = $sth->fetchObject()) {
      if ($result->count > 0) {
        return true;
      } else {
        return false;
      }
    }
  }
  return false;
}

function gen_recoverykey($mail) {
  global $dbh, $config;
  $pwhash=md5(rand().$mail);
  $pwlink = preg_replace("/\?.*/", "", $_SERVER["HTTP_REFERER"]);
  $pwlink .= "?action=changepass&key=$pwhash";
  $sth=$dbh->prepare("INSERT INTO ".$config['sql_recovery_table']." (user_hash, user_name) VALUE (?,?);");
  $sth->execute(array($pwhash, $mail));
  return $pwlink;
}

function verify_recoverykey($key) {
  global $dbh, $config;
  $sth=$dbh->prepare("SELECT * FROM ".$config['sql_recovery_table']." WHERE user_hash=?");
  $sth->execute(array($key));
  while ($result = $sth->fetchObject()) {
    return $result->user_name;
  }
  return "";
}

function set_password($username, $password) {
  global $dbh, $config;
  $sth = $dbh->prepare($config['sql_update_password']);
  $sth->execute(array($password, $username));
  $sth = $dbh->prepare("DELETE FROM ".$config['sql_recovery_table']." WHERE user_name=?");
  $sth->execute(array($username));

  return true;
}

if ( ! empty($_REQUEST["action"])) {
  // $_REQUEST['user']
  if ($_REQUEST["action"] == "changepass") {
    if ( preg_replace("[^a-f0-9]", "", $_REQUEST["key"]) != $_REQUEST["key"] ) {
      $error .= "Ung&uuml;ltiger Key ".$_REQUEST["key"];
      $status = 3;
    } else {
      $username=verify_recoverykey($_REQUEST["key"]);
      if ( "" == $username ) {
        $error .= "Unbekannter Key ".$_REQUEST["key"];
        $status = 3;
      } else {
        # Neues Passwort
        exec($config['pwgen'], $result, $return);
        if ($return != 0) {
          $error .= $config['pwgen']." nicht aufrufbar";
          $status = 3;
        } else {
          if ( ! set_password($username, $result[0])) {
            $error .= "Passwort setzen schlug fehl";
            $status = 3;
          } else {
            $smarty->assign('passwd', $result[0]);
            $status = 4;
          }
        }
      }
    }
  } else {
    if ( ! verify_email_syntax($_REQUEST["user"])) {
      $error .= "Ung&uuml;ltige Mailadressensyntax: ".$_REQUEST["user"];
      $smarty->assign('user', $_REQUEST["user"]);
      $status = 2;
    } elseif ( ! verify_user_exists($_REQUEST["user"])) {
      $error .= "Die Adresse " . $_REQUEST["user"] . " existiert nicht in der Datenbank";;
      $smarty->assign('user', $_REQUEST["user"]);
      $status = 2;
    } else {
      $mail = Mail::factory('smtp', array(
          		    'host'	=>  $config["SMTPhost"],
          		    'port'	=>  $config["SMTPport"],
          		    'auth'	=>  FALSE,
          		    'debug'	=>  FALSE,
          		    'persist'	=>  FALSE )); 
      
      $mailrecipient = $_REQUEST["user"];
      $mailheaders["To"] = $_REQUEST["user"];
      $mailheaders["From"] = $config["SMTPfrom"];
      $mailheaders["Subject"] = $config["SMTPsubject"];
      $mailheaders["Reply-To"] = $config["SMTPfrom"];
      $mailheaders["Return-path"] = $config["SMTPfrom"];

      $pwlink = gen_recoverykey($_REQUEST["user"]);
      $mailbody = "Guten Tag,\n\nDer von ".$_SERVER["REMOTE_ADDR"]." angeforderte Passwort Link lautet $pwlink\nMfG,\n        Maia";

      if ( ! $mail->send($mailrecipient, $mailheaders, $mailbody) ) {
        $error = "Mailfehler";
      }

      $smarty->assign('user', $_REQUEST["user"]);
      $status = 1;
    }
  }
  $smarty->assign('error', $error);
} else {
  $status = 0;
}

$smarty->assign('debug', $debug);
$smarty->assign('status', $status);
$smarty->display('password_recovery.tpl');
?>
